import { useMemo } from 'react';
import { Subject, zip } from 'rxjs';
import { map, mergeMap } from 'rxjs/operators';
import { fileToImage } from './useRxFileToImage';
export function fromDropImageEvent(dragEvent) {
    return [
        dragEvent.dataTransfer && dragEvent.dataTransfer.items,
        dragEvent
    ];
}
export var preventDragOver = function (event) { return event.preventDefault(); };
export function useRxDropImage() {
    var _a = useMemo(function () {
        var subject = new Subject();
        return [
            // prettier-ignore
            subject.pipe(map(fromDropImageEvent), mergeMap(function (payload) { return zip.apply(void 0, fileToImage(payload)); })),
            {
                onDragOver: preventDragOver,
                onDrop: function (event) {
                    subject.next(event);
                }
            }
        ];
    }, []), source$ = _a[0], props = _a[1];
    return [source$, props];
}
//# sourceMappingURL=useRxDropImage.js.map