import { useMemo } from 'react';
import { merge, zip, from } from 'rxjs';
import { map, mergeMap } from 'rxjs/operators';
function isFile(object) {
    return object instanceof File;
}
export function fileToImage(_a) {
    var items = _a[0], event = _a[1];
    var list = [];
    if (items && items.length) {
        var _loop_1 = function (i) {
            var item = items[i];
            if (item.type.indexOf('image') !== -1) {
                event.preventDefault();
                var file_1 = isFile(item) ? item : item.getAsFile();
                if (file_1) {
                    list.push(from(getBase64ImageURL(file_1)).pipe(map(function (url) { return ({ url: url, file: file_1 }); })));
                }
            }
        };
        for (var i = 0; i < items.length; i++) {
            _loop_1(i);
        }
    }
    return list;
}
export function useRxFileToImage(source$) {
    return useMemo(function () {
        return merge.apply(void 0, (Array.isArray(source$) ? source$ : [source$])).pipe(mergeMap(function (_a) {
            var items = _a[0], event = _a[1];
            return zip.apply(void 0, fileToImage([items, event]));
        }));
    }, [source$]);
}
var getBase64ImageURL = function (file) {
    return new Promise(function (resolve, reject) {
        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        var img = new Image();
        img.onload = function () {
            canvas.width = img.width;
            canvas.height = img.height;
            ctx.drawImage(img, 0, 0);
            resolve(canvas.toDataURL(file.type));
        };
        img.src = URL.createObjectURL(file);
        img.onerror = reject;
    });
};
//# sourceMappingURL=useRxFileToImage.js.map