var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { useMemo, useRef } from 'react';
import { Subject, merge, pipe as rxPipe } from 'rxjs';
import { startWith, filter, combineLatest, map } from 'rxjs/operators';
import { useRxInput } from './useRxInput';
export function useRxInputComposing(_a) {
    if (_a === void 0) { _a = {}; }
    var pipe = _a.pipe, options = __rest(_a, ["pipe"]);
    var compositionStart$ = useRef(new Subject());
    var compositionEnd$ = useRef(new Subject());
    var isComposing = useMemo(function () { return function (source$) {
        var isComposing$ = merge(compositionStart$.current.pipe(map(function () { return true; })), compositionEnd$.current.pipe(map(function () { return false; }))).pipe(startWith(false));
        return source$.pipe(combineLatest(isComposing$), filter(function (_a) {
            var isComposing = _a[1];
            return !isComposing;
        }), map(function (_a) {
            var value = _a[0];
            return value;
        }), pipe || rxPipe());
    }; }, [pipe]);
    var _b = useRxInput(__assign({ pipe: isComposing }, options)), value = _b[0], inputProps = _b[1];
    var newProps = useMemo(function () {
        var handler = function (subject) { return function (event) { return subject.next(event); }; };
        return __assign(__assign({}, inputProps), { onCompositionStart: handler(compositionStart$.current), onCompositionEnd: handler(compositionEnd$.current) });
    }, [inputProps]);
    return [value, newProps];
}
//# sourceMappingURL=useRxInputComposing.js.map