import { useMemo } from 'react';
import { Subject, zip } from 'rxjs';
import { map, mergeMap } from 'rxjs/operators';
import { fileToImage } from './useRxFileToImage';
export function fromPasteImageEvent(clipboardEvent) {
    return [
        clipboardEvent.clipboardData && clipboardEvent.clipboardData.items,
        clipboardEvent
    ];
}
export function useRxPasteImage() {
    var _a = useMemo(function () {
        var subject = new Subject();
        return [
            subject.pipe(map(fromPasteImageEvent), mergeMap(function (payload) { return zip.apply(void 0, fileToImage(payload)); })),
            {
                onPaste: function (event) { return subject.next(event); }
            }
        ];
    }, []), source$ = _a[0], props = _a[1];
    return [source$, props];
}
//# sourceMappingURL=useRxPasteImage.js.map