var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { useRef, useCallback, useState, useEffect } from 'react';
import { Subject } from 'rxjs';
import { map, tap, debounceTime } from 'rxjs/operators';
function getPos(el) {
    return el instanceof Window
        ? { x: el.scrollX, y: el.scrollY }
        : { x: el.scrollTop, y: el.scrollLeft };
}
var initialState = {
    x: 0,
    y: 0,
    scrolling: false
};
export function useRxScroll(ob) {
    var subject = useRef(new Subject());
    var onScroll = useCallback(function (event) { return subject.current.next(event); }, []);
    var _a = useState(initialState), state = _a[0], setState = _a[1];
    useEffect(function () {
        var subscription = (ob || subject.current)
            .pipe(map(function (event) { return (__assign(__assign({}, getPos(event.currentTarget)), { scrolling: true })); }), tap(function (state) { return setState(state); }), debounceTime(150), tap(function (state) { return setState(__assign(__assign({}, state), { scrolling: false })); }))
            .subscribe();
        return function () {
            subscription.unsubscribe();
            setState(initialState);
        };
    }, [ob]);
    var props = { onScroll: onScroll };
    return [state, props];
}
//# sourceMappingURL=useRxScroll.js.map