import { useMemo } from 'react';
import { Subject, zip } from 'rxjs';
import { map, mergeMap } from 'rxjs/operators';
import { fileToImage } from './useRxFileToImage';
export function fromChangeEvent(event) {
    return [event.target.files && event.target.files, event];
}
export function useRxUploadImage() {
    var _a = useMemo(function () {
        var subject = new Subject();
        return [
            subject.pipe(map(fromChangeEvent), mergeMap(function (payload) { return zip.apply(void 0, fileToImage(payload)); })),
            {
                onChange: function (event) { return subject.next(event); }
            }
        ];
    }, []), source$ = _a[0], props = _a[1];
    return [source$, props];
}
//# sourceMappingURL=useRxUploadImage.js.map