"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRxDropImage = exports.preventDragOver = exports.fromDropImageEvent = void 0;
var react_1 = require("react");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var useRxFileToImage_1 = require("./useRxFileToImage");
function fromDropImageEvent(dragEvent) {
    return [
        dragEvent.dataTransfer && dragEvent.dataTransfer.items,
        dragEvent
    ];
}
exports.fromDropImageEvent = fromDropImageEvent;
exports.preventDragOver = function (event) { return event.preventDefault(); };
function useRxDropImage() {
    var _a = react_1.useMemo(function () {
        var subject = new rxjs_1.Subject();
        return [
            // prettier-ignore
            subject.pipe(operators_1.map(fromDropImageEvent), operators_1.mergeMap(function (payload) { return rxjs_1.zip.apply(void 0, useRxFileToImage_1.fileToImage(payload)); })),
            {
                onDragOver: exports.preventDragOver,
                onDrop: function (event) {
                    subject.next(event);
                }
            }
        ];
    }, []), source$ = _a[0], props = _a[1];
    return [source$, props];
}
exports.useRxDropImage = useRxDropImage;
//# sourceMappingURL=useRxDropImage.js.map