"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRxFileToImage = exports.fileToImage = void 0;
var react_1 = require("react");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
function isFile(object) {
    return object instanceof File;
}
function fileToImage(_a) {
    var items = _a[0], event = _a[1];
    var list = [];
    if (items && items.length) {
        var _loop_1 = function (i) {
            var item = items[i];
            if (item.type.indexOf('image') !== -1) {
                event.preventDefault();
                var file_1 = isFile(item) ? item : item.getAsFile();
                if (file_1) {
                    list.push(rxjs_1.from(getBase64ImageURL(file_1)).pipe(operators_1.map(function (url) { return ({ url: url, file: file_1 }); })));
                }
            }
        };
        for (var i = 0; i < items.length; i++) {
            _loop_1(i);
        }
    }
    return list;
}
exports.fileToImage = fileToImage;
function useRxFileToImage(source$) {
    return react_1.useMemo(function () {
        return rxjs_1.merge.apply(void 0, (Array.isArray(source$) ? source$ : [source$])).pipe(operators_1.mergeMap(function (_a) {
            var items = _a[0], event = _a[1];
            return rxjs_1.zip.apply(void 0, fileToImage([items, event]));
        }));
    }, [source$]);
}
exports.useRxFileToImage = useRxFileToImage;
var getBase64ImageURL = function (file) {
    return new Promise(function (resolve, reject) {
        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        var img = new Image();
        img.onload = function () {
            canvas.width = img.width;
            canvas.height = img.height;
            ctx.drawImage(img, 0, 0);
            resolve(canvas.toDataURL(file.type));
        };
        img.src = URL.createObjectURL(file);
        img.onerror = reject;
    });
};
//# sourceMappingURL=useRxFileToImage.js.map