import { InputHTMLAttributes } from 'react';
import { Observable } from 'rxjs';
export declare type RxInputEl = HTMLInputElement | HTMLTextAreaElement | HTMLSelectElement;
export declare type RxInputPipe<O> = (ob: Observable<string>) => Observable<string | O>;
export interface RxInputOptions<O> {
    test?: any;
    defaultValue?: string;
    pipe?: RxInputPipe<O>;
}
declare type State<O, T extends RxInputEl = HTMLInputElement> = [O, {
    value: string;
    onChange: NonNullable<InputHTMLAttributes<T>['onChange']>;
}];
export declare function useRxInput<O, T extends RxInputEl = HTMLInputElement>(options?: RxInputOptions<O> & {
    pipe?: undefined;
}): State<string, T>;
export declare function useRxInput<O, T extends RxInputEl = HTMLInputElement>(options?: RxInputOptions<O> & {
    pipe: RxInputPipe<O>;
}): State<undefined | O, T>;
export {};
