"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRxInput = void 0;
var react_1 = require("react");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
function useRxInput(_a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.defaultValue, defaultValue = _c === void 0 ? '' : _c, pipe = _b.pipe;
    var subject = react_1.useRef(new rxjs_1.Subject());
    var _d = react_1.useState(defaultValue), value = _d[0], setValue = _d[1];
    var _e = react_1.useState(typeof pipe === 'undefined' ? defaultValue : undefined), output = _e[0], setOutput = _e[1];
    var handleChange = react_1.useCallback(function (event) { return subject.current.next(event); }, []);
    react_1.useEffect(function () {
        var subsciprtion = subject.current
            .pipe(operators_1.map(function (evt) { return evt.target.value; }), operators_1.tap(function (next) { return setValue(next); }), operators_1.startWith(defaultValue), pipe || rxjs_1.pipe())
            .subscribe(setOutput);
        return function () { return subsciprtion.unsubscribe(); };
    }, [defaultValue, pipe]);
    return [output, { value: value, onChange: handleChange }];
}
exports.useRxInput = useRxInput;
//# sourceMappingURL=useRxInput.js.map