import { InputHTMLAttributes } from 'react';
import { RxInputOptions, RxInputPipe, RxInputEl } from './useRxInput';
interface InputProps<T> extends Required<Pick<InputHTMLAttributes<T>, 'onChange' | 'onCompositionStart' | 'onCompositionEnd'>> {
    value: string;
}
declare type State<O, T extends RxInputEl = HTMLInputElement> = [O, InputProps<T>];
export declare function useRxInputComposing<O, T extends RxInputEl = HTMLInputElement>(options?: RxInputOptions<O> & {
    pipe?: undefined;
}): State<string, T>;
export declare function useRxInputComposing<O, T extends RxInputEl = HTMLInputElement>(options?: RxInputOptions<O> & {
    pipe: RxInputPipe<O>;
}): State<undefined | O, T>;
export {};
