"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRxInputComposing = void 0;
var react_1 = require("react");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var useRxInput_1 = require("./useRxInput");
function useRxInputComposing(_a) {
    if (_a === void 0) { _a = {}; }
    var pipe = _a.pipe, options = __rest(_a, ["pipe"]);
    var compositionStart$ = react_1.useRef(new rxjs_1.Subject());
    var compositionEnd$ = react_1.useRef(new rxjs_1.Subject());
    var isComposing = react_1.useMemo(function () { return function (source$) {
        var isComposing$ = rxjs_1.merge(compositionStart$.current.pipe(operators_1.map(function () { return true; })), compositionEnd$.current.pipe(operators_1.map(function () { return false; }))).pipe(operators_1.startWith(false));
        return source$.pipe(operators_1.combineLatest(isComposing$), operators_1.filter(function (_a) {
            var isComposing = _a[1];
            return !isComposing;
        }), operators_1.map(function (_a) {
            var value = _a[0];
            return value;
        }), pipe || rxjs_1.pipe());
    }; }, [pipe]);
    var _b = useRxInput_1.useRxInput(__assign({ pipe: isComposing }, options)), value = _b[0], inputProps = _b[1];
    var newProps = react_1.useMemo(function () {
        var handler = function (subject) { return function (event) { return subject.next(event); }; };
        return __assign(__assign({}, inputProps), { onCompositionStart: handler(compositionStart$.current), onCompositionEnd: handler(compositionEnd$.current) });
    }, [inputProps]);
    return [value, newProps];
}
exports.useRxInputComposing = useRxInputComposing;
//# sourceMappingURL=useRxInputComposing.js.map