"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRxScroll = void 0;
var react_1 = require("react");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
function getPos(el) {
    return el instanceof Window
        ? { x: el.scrollX, y: el.scrollY }
        : { x: el.scrollTop, y: el.scrollLeft };
}
var initialState = {
    x: 0,
    y: 0,
    scrolling: false
};
function useRxScroll(ob) {
    var subject = react_1.useRef(new rxjs_1.Subject());
    var onScroll = react_1.useCallback(function (event) { return subject.current.next(event); }, []);
    var _a = react_1.useState(initialState), state = _a[0], setState = _a[1];
    react_1.useEffect(function () {
        var subscription = (ob || subject.current)
            .pipe(operators_1.map(function (event) { return (__assign(__assign({}, getPos(event.currentTarget)), { scrolling: true })); }), operators_1.tap(function (state) { return setState(state); }), operators_1.debounceTime(150), operators_1.tap(function (state) { return setState(__assign(__assign({}, state), { scrolling: false })); }))
            .subscribe();
        return function () {
            subscription.unsubscribe();
            setState(initialState);
        };
    }, [ob]);
    var props = { onScroll: onScroll };
    return [state, props];
}
exports.useRxScroll = useRxScroll;
//# sourceMappingURL=useRxScroll.js.map