'use strict';
Object.defineProperty(exports, '__esModule', { value: true });
const rxjs_1 = require('rxjs');
const operators_1 = require('rxjs/operators');
function isComposing(element) {
  const composingStart$ = rxjs_1
    .fromEvent(element, 'compositionstart')
    .pipe(operators_1.map(() => true));
  const composingEnd$ = rxjs_1
    .fromEvent(element, 'compositionend')
    .pipe(operators_1.map(() => false));
  const isComposing$ = rxjs_1
    .merge(composingStart$, composingEnd$)
    .pipe(operators_1.startWith(false));
  return source$ => {
    return source$.pipe(
      operators_1.combineLatest(isComposing$),
      operators_1.filter(([, isComposing]) => !isComposing),
      operators_1.map(([evt]) => evt)
    );
  };
}
exports.isComposing = isComposing;
//# sourceMappingURL=isComposing.js.map
